# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['ProviderArgs', 'Provider']

@pulumi.input_type
class ProviderArgs:
    def __init__(__self__, *,
                 jwt_secret: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Provider resource.
        :param pulumi.Input[str] jwt_secret: The SupavisorNative JWT secret.
        """
        if jwt_secret is None:
            jwt_secret = _utilities.get_env('SUPAVISOR_NATIVE_JWT_SECRET')
        if jwt_secret is not None:
            pulumi.set(__self__, "jwt_secret", jwt_secret)

    @property
    @pulumi.getter(name="jwtSecret")
    def jwt_secret(self) -> Optional[pulumi.Input[str]]:
        """
        The SupavisorNative JWT secret.
        """
        return pulumi.get(self, "jwt_secret")

    @jwt_secret.setter
    def jwt_secret(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "jwt_secret", value)


class Provider(pulumi.ProviderResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 jwt_secret: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The provider type for the SupavisorNative package.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] jwt_secret: The SupavisorNative JWT secret.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ProviderArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The provider type for the SupavisorNative package.

        :param str resource_name: The name of the resource.
        :param ProviderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProviderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 jwt_secret: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProviderArgs.__new__(ProviderArgs)

            if jwt_secret is None:
                jwt_secret = _utilities.get_env('SUPAVISOR_NATIVE_JWT_SECRET')
            __props__.__dict__["jwt_secret"] = None if jwt_secret is None else pulumi.Output.secret(jwt_secret)
        super(Provider, __self__).__init__(
            'supavisor-native',
            resource_name,
            __props__,
            opts)

